def példányszám(átk, faj):
    ennyi = 0
    for állat in átk:
        if állat['faj'] == faj:
            ennyi += 1
    return ennyi

def átlagéletkor(átk, faj):
    korösszeg = 0
    ennyi = 0
    for állat in átk:
        if állat['faj'] == faj:
            korösszeg += állat['kor']
            ennyi += 1
    return korösszeg/ennyi

állatok = []
with open('allatok.txt') as forrásfájl:
    for sor in forrásfájl:
        sor = sor.strip().split()
        állat = {'név': sor[0], 'faj': sor[1], 'kor':int(sor[2])}
        állatok.append(állat)

# 1. feladat
print(len(állatok), 'állatunk van összesen.')
print(f'{len(állatok)} állatunk van összesen.')

# 2. feladat
legöregebb_kora = 0
legöregebb_neve = None
for állat in állatok:
    if állat['kor'] > legöregebb_kora:
        legöregebb_kora = állat['kor']
        legöregebb_neve = állat['név']
print('A legöregebb állatunk: ', legöregebb_neve, '.', sep='')
print(f'A legöregebb állatunk: {legöregebb_neve}.')
# egysoros megoldás
legöregebb_neve = max(állatok, key=lambda x: x['kor'])['név']
print(f'A legöregebb állatunk: {legöregebb_neve}.')

# 3. feladat
faj = input('Adjon meg egy fajnevet! ')

# hosszú megoldás feltételes ciklussal
index = 0
hossz = len(állatok)
while index < hossz and állatok[index]['faj'] != faj:
    index += 1
if index < hossz:
    print('Van', faj, 'a tanyán.')
else:
    print('Nincs',  faj, 'a tanyán.')

# hosszú megoldás bejárós ciklussal
van = False
for állat in állatok:
    if állat['faj'] == faj:
        van = True
        break
if van:
    print('Van', faj, 'a tanyán.')
else:
    print('Nincs',  faj, 'a tanyán.')

# hosszú megoldás a bejárós ciklus else-záradékával
for állat in állatok:
    if állat['faj'] == faj:
        print('Van', faj, 'a tanyán.')
        break
else:
    print('Nincs',  faj, 'a tanyán.')


# rövid megoldás
van = faj in { állat['faj'] for állat in állatok }
print('Van' if van else 'Nincs', faj, 'a tanyán.')

# 4. feladat
fajhalmaz = set()
for állat in állatok:
    fajhalmaz.add(állat['faj'])

print('Állatfajok listája: ', ', '.join(fajhalmaz), '.', sep='')
print(f'Állatfajok listája: {", ".join(fajhalmaz)}.')
faj = input('Válasszon egy fajnevet! ')

van = False
for állat in állatok:
    if állat['faj'] == faj and állat['kor'] == 1:
        van = True
print('Van' if van else 'Nincs', 'egyéves', faj, 'a tanyán.')

# 5. feladat
legtöbb_példányszáma = 0
legtöbb_faja = None
for faj in fajhalmaz:
    szám = példányszám(állatok, faj)
    if szám > legtöbb_példányszáma:
        legtöbb_példányszáma = szám
        legtöbb_faja = faj

print('A ', legtöbb_faja, ' példányszáma: ', legtöbb_példányszáma, '.', sep='')
print(f'A {legtöbb_faja} példányszáma: {legtöbb_példányszáma}.')


# 6. feladat
átlagéletkorok = {}
for faj in fajhalmaz:
    átlag = átlagéletkor(állatok, faj)
    átlagéletkorok[faj] = átlag
# egyszerûen:
for faj, átlagéletkor in átlagéletkorok.items():
    print(faj, ': ', átlagéletkor, sep='')
# rendezetten:
for faj, átlagéletkor in átlagéletkorok.items():
    print(f'{faj:>14}: {átlagéletkor:>4.2f}')

# 7. feladat
for faj in fajhalmaz:
    with open(faj + '.txt', 'w') as célfájl:
        for állat in állatok:
            if állat['faj'] == faj:
                print(állat['név'], file=célfájl)
