#!/usr/bin/env python3

def átlag(rendes_jegyek, témazáró_jegyek):
    összeg = sum(rendes_jegyek) + sum(témazáró_jegyek) * 2
    osztó = len(rendes_jegyek) + len(témazáró_jegyek) * 2
    return round(összeg/osztó, 1)

diákok = []
with open('naplo.txt') as forrásfájl:
    for sor in forrásfájl:
        sor = sor.strip().split(', ')
        diák = {}
        diák['név'] = sor[0]
        diák['osztály'] = sor[1]
        jegyek = sor[2].split()
        diák['rendes_jegyek'] = []
        diák['témazáró_jegyek'] = []
        for jegy in jegyek:
            if len(jegy) == 1:
                diák['rendes_jegyek'].append(int(jegy))
            else:
                diák['témazáró_jegyek'].append(int(jegy[0]))
        diákok.append(diák)

print('11. évfolyamra jár:')
for diák in diákok:
    if diák['osztály'][:2] == '11':
        print(diák['név'])

print('Nem írt meg minden témazárót:')
for diák in diákok:
    if len(diák['témazáró_jegyek']) < 3:
        print(diák['név'], ': ', ', '.join(map(str, diák['témazáró_jegyek'])), sep='')

legkevesebb_szám = 10
legkevesebb_név = None
for diák in diákok:
    if diák['osztály'] == '11x' and len(diák['témazáró_jegyek']) < legkevesebb_szám:
        legkevesebb_szám = len(diák['témazáró_jegyek'])
        legkevesebb_név = diák['név']
print(legkevesebb_név, 'írta a legkeveseeb témazárót a 11. x osztályban.')

legtöbb_rendes_jegy = 0
for diák in diákok: # ebben a ciklusban megállapítjuk, hogy mennyi a legtöbb rendes jegy
    if len(diák['rendes_jegyek']) > legtöbb_rendes_jegy:
        legtöbb_rendes_jegy = len(diák['rendes_jegyek'])
print('Felelésre számíthat:')
for diák in diákok: # ebben a ciklusban kiírjuk, hogy ki számíthat felelésre
    if len(diák['rendes_jegyek']) < legtöbb_rendes_jegy * 0.8:
        print(diák['név'])

for diák in diákok:
    á = átlag(diák['rendes_jegyek'], diák['témazáró_jegyek'])
    if á <= 1.7:
        jegy = 1
    elif 1.7 < á < 4.5:
        jegy = int(round(á, 0))
    else:
        jegy = 5
    print(diák['név'], 'átlaga:', á, 'jegye:', jegy)

