#!/usr/bin/env python3

class Diák():
    def __init__(self, sor):
        self.név = sor[0]
        self.osztály = sor[1]
        jegyek = sor[2].split()
        self.rendes_jegyek = []
        self.témazáró_jegyek = []
        for jegy in jegyek:
            if len(jegy) == 1:
                self.rendes_jegyek.append(int(jegy))
            else:
                self.témazáró_jegyek.append(int(jegy[0]))

    def évfolyam(self):
        return int(self.osztály[:2])

    def osztálybetû(self):
        return self.osztály[2:]

    def osztály(self):
        return self.osztály

    def megírt_minden_témazárót(self, idei_témazárók_száma):
        if self.jegyek_száma('témazáró') == idei_témazárók_száma:
            return True
        else:
            return False

    def jegyek_száma(self, milyen):
        if milyen == 'témazáró':
            return len(self.témazáró_jegyek)
        elif milyen == 'rendes':
            return len(self.rendes_jegyek)
        elif milyen == 'összes':
            return len(self.témazáró_jegyek) + len(self.rendes_jegyek)

    def átlag(self):
        összeg = sum(self.rendes_jegyek) + sum(self.témazáró_jegyek) * 2
        osztó = self.jegyek_száma('összes') + self.jegyek_száma('témazáró')
        return round(összeg/osztó, 2)

    def év_végi_jegy(self):
        á = self.átlag()
        if á <= 1.7:
            return 1
        elif 1.7 < á < 4.5:
            return int(round(á, 0))
        else:
            return 5

diákok = []
with open('naplo.txt') as forrásfájl:
    for sor in forrásfájl:
        sor = sor.strip().split(', ')
        diák = Diák(sor)
        diákok.append(diák)

print('11. évfolyamra jár:')
for diák in diákok:
    if diák.évfolyam() == '11':
        print(diák.név)

print('Nem írt meg minden témazárót:')
for diák in diákok:
    if not diák.megírt_minden_témazárót(3):
        print(diák.név, diák.jegyek_száma('témazáró'))

legkevesebb_szám = 10
legkevesebb_név = None
for diák in diákok:
    if diák.osztály == '11x' and diák.jegyek_száma('témazáró') < legkevesebb_szám:
        legkevesebb_szám = diák.jegyek_száma('témazáró')
        legkevesebb_név = diák.név
print(legkevesebb_név, 'írta a legkeveseeb témazárót a 11. x osztályban.')

legtöbb_rendes_jegy = 0
for diák in diákok: # ebben a ciklusban megállapítjuk, hogy mennyi a legtöbb rendes jegy
    if diák.jegyek_száma('rendes') > legtöbb_rendes_jegy:
        legtöbb_rendes_jegy = diák.jegyek_száma('rendes')
print('Felelésre számíthat:')
for diák in diákok: # ebben a ciklusban kiírjuk, hogy ki számíthat felelésre
    if diák.jegyek_száma('rendes') < legtöbb_rendes_jegy * 0.8:
        print(diák.név)

for diák in diákok:
    print(diák.név, 'átlaga:', diák.átlag(), 'jegye:', diák.év_végi_jegy())

