#!/usr/bin/env python3

import tkinter
import random

def fájlt_beolvas():
    szójegyzék = {}
    with open('szavak.txt') as forrásfájl:
        for sor in forrásfájl:
            magyar, angol = sor.strip().split()
            szójegyzék[magyar] = angol
    megmaradó_szavak = random.sample(list(szójegyzék), 9)
    szójegyzék = { kulcs: érték for kulcs, érték in szójegyzék.items() if kulcs in megmaradó_szavak }
    return szójegyzék

class App():
    def __init__(self, master, szójegyzék):
        self.szójegyzék = szójegyzék
        self.keresett_szó = random.choice(list(self.szójegyzék.keys()))
        self.kérdés_keret = tkinter.Frame(master)
        self.kérdés_keret.pack()
        self.kérdés = tkinter.Label(self.kérdés_keret, text=self.keresett_szó + ' angolul:', pady=10)
        self.kérdés.pack()
        self.gombok_keret = tkinter.Frame(master)
        self.gombok_keret.pack()
        self.gombokat_készít()
        self.gombokat_megjelenít()

    def gombokat_készít(self): 
        self.gombok = {}
        for angol in self.szójegyzék.values():
            self.gombok[angol] = tkinter.Button(self.gombok_keret,
                                text=angol,
                                height=3, width=8,
                                command=lambda angol_szó=angol: self.egyezést_vizsgál(angol_szó))

    def gombokat_megjelenít(self):
        megjelenítendő_gombok = list(self.gombok)
        for sor in range(3):
            for oszlop in range(3):
                aktuális_gomb = megjelenítendő_gombok.pop()
                self.gombok[aktuális_gomb].grid(row=sor, column=oszlop)

    def egyezést_vizsgál(self, szó):
        if szó == self.szójegyzék[self.keresett_szó]:
            self.gombok[szó].config(state='disabled')
            self.keresett_szót_frissít()

    def keresett_szót_frissít(self):
        még_nem_kérdezett_szavak = []
        for magyar, angol in self.szójegyzék.items():
            if self.gombok[angol]['state'] != 'disabled':
                még_nem_kérdezett_szavak.append(magyar)
        if még_nem_kérdezett_szavak:
            self.keresett_szó = random.choice(még_nem_kérdezett_szavak)
            self.kérdés.configure(text=self.keresett_szó + ' angolul:')
        else:
            self.kérdés.configure(text=f'Kifogytam a szavakból.')



főablak = tkinter.Tk()
főablak.title('Pár szóban')
app = App(főablak, fájlt_beolvas())
főablak.mainloop()


